let SXPL = window.SXPluginSDKWebLib;

let BannerState =
    {
        None: 0,
        Show: 1,
        Hide: 2
    };

let SXPLSXADSOppoVivoMiniBanner = function () {
    this.mBanner = null;
    this.mAdsName = null
    this.mAdsUnitID = null;
    this.mListener = null;
    this.mOtherParm = null;

    this.mIsCreated = false;
    this.mLogicShow = false;
    this.mState = 0;
};

SXPLSXADSOppoVivoMiniBanner.prototype._create = function () {
    if (this.mBanner) this.mBanner.destroy();

    this.mBanner = qg.createBannerAd({
        posId: this.mAdsUnitID,
        adUnitId: this.mAdsUnitID,
        style: {}
    });
    this.mBanner.onLoad(this._onLoad.bind(this));
    this.mBanner.onError(this._onError.bind(this));
};

SXPLSXADSOppoVivoMiniBanner.prototype._onLoad = function () {
    console.log("SXADSOppoVivoMini Banner 加载成功");
    if (this.mLogicShow) {
        this.show();
    }
};

SXPLSXADSOppoVivoMiniBanner.prototype._onError = function (error) {
    console.log("SXADSOppoVivoMini Banner 加载失败! " + JSON.stringify(error));
    this.mListener.onAdFailedToLoad(this.mAdsName, "SXADSOppoVivoMini Banner: " + JSON.stringify(error));
};

SXPLSXADSOppoVivoMiniBanner.prototype.show = function () {
    if (this.mBanner && this.mState != BannerState.Show) {
        this.mState = BannerState.Show;
        this.mBanner.show().catch(err => {
            console.log("Vivo Mini Banner Show err:" + JSON.stringify(err));
            this.mState = BannerState.None;
        });
    }
}

SXPLSXADSOppoVivoMiniBanner.prototype.GetSDKID = function () {
    return 0
};
SXPLSXADSOppoVivoMiniBanner.prototype.Create = function () {
    if (this.mAdsUnitID == null || this.mAdsUnitID.length == 0) return;
    this.mIsCreated = true;
};

SXPLSXADSOppoVivoMiniBanner.prototype.Init = function (adsID, adsUnitID) {
    this.mAdsName = adsID;
    this.mAdsUnitID = adsUnitID;
    this.mListener = SXPL.SXPluginSDK.ADSListener;
};

SXPLSXADSOppoVivoMiniBanner.prototype.SetOtherParam = function (jsonObject) {
    this.mOtherParm = jsonObject;
};
SXPLSXADSOppoVivoMiniBanner.prototype.SetBannerSize = function () {
};
SXPLSXADSOppoVivoMiniBanner.prototype.SetBannerPos = function () {
};
SXPLSXADSOppoVivoMiniBanner.prototype.ForceUpdatePosition = function (x, y) {
};
SXPLSXADSOppoVivoMiniBanner.prototype.LoadAds = function () {
    this._create();
};
SXPLSXADSOppoVivoMiniBanner.prototype.ShowAds = function () {
    this.mLogicShow = true;
    this.show();
};
SXPLSXADSOppoVivoMiniBanner.prototype.HideAds = function () {
    this.mLogicShow = false;
    if (this.mBanner) {
        this.mBanner.hide();
        this.mState = BannerState.Hide;
    }
};
SXPLSXADSOppoVivoMiniBanner.prototype.Destory = function () {
    this.mIsCreated = false;
    if (this.mBanner) this.mBanner.destroy();
    this.mState = BannerState.None;
    this.mBanner = null;
};
SXPLSXADSOppoVivoMiniBanner.prototype.AdsIsReady = function () {
    return true;
};
SXPLSXADSOppoVivoMiniBanner.prototype.IsCreated = function () {
    return this.mIsCreated;
};

//------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------

SXPluginSDKWebLib.VivoNativeAds = {};

let SXPLSXADSOppoVivoMiniNative = function () {
    this.mNative = null;
    this.mNativeCurrentAd = null;

    this.mAdsName = null
    this.mAdsUnitID = null;
    this.mListener = null;
    this.mOtherParm = null;

    this.mIsCreated = false;
    this.mIsLoad = false;
    
    this.NativeViewCom = null;
};

SXPLSXADSOppoVivoMiniNative.prototype._create = function () {
    if (this.NativeViewCom) {
        this.mNative = qg.createNativeAd({
            posId: this.mAdsUnitID,
            adUnitId: this.mAdsUnitID
        });
        this.mNative.onLoad(this._onLoad.bind(this));
        this.mNative.onError(this._onError.bind(this));
        this.mNative.load();
    }
};

SXPLSXADSOppoVivoMiniNative.prototype.ReportAdShow = function () {
    if (this.mNativeCurrentAd) {
        console.log("SXADSOppoVivoMini reportAdShow");
        this.mNative.reportAdShow({adId: this.mNativeCurrentAd.adId.toString()});
    }
};

SXPLSXADSOppoVivoMiniNative.prototype.ReportAdClick = function () {
    if (this.mNativeCurrentAd) {
        console.log("SXADSOppoVivoMini reportAdClick");
        this.mNative.reportAdClick({adId: this.mNativeCurrentAd.adId.toString()});
    }
};

SXPLSXADSOppoVivoMiniNative.prototype._onLoad = function (res) {
    if (res && res.adList) {
        let nativeCurrentAd = res.adList.pop();
        if (nativeCurrentAd) {
            this.mNativeCurrentAd = nativeCurrentAd;
            console.log("SXADSOppoVivoMini Native 加载成功");
            this.mIsLoad = true;

            this.mListener.onAdLoaded(this.mAdsName);

            if (this.NativeViewCom.onAdLoaded) {
                this.NativeViewCom.onAdLoaded(this.mNativeCurrentAd);
            }
        }
    }
};

SXPLSXADSOppoVivoMiniNative.prototype._onError = function (error) {
    console.log("SXADSOppoVivoMini Native 加载失败! " + error);
    this.mListener.onAdFailedToLoad(this.mAdsName, "SXADSOppoVivoMini Native: " + error);
    if (this.NativeViewCom.onAdError) {
        this.NativeViewCom.onAdError(error);
    }
};

SXPLSXADSOppoVivoMiniNative.prototype.GetSDKID = function () {
    return 0
};
SXPLSXADSOppoVivoMiniNative.prototype.Create = function () {
    if (this.mAdsUnitID == null) return;
    this.mIsCreated = true;
};

SXPLSXADSOppoVivoMiniNative.prototype.Init = function (adsID, adsUnitID) {
    this.mAdsName = adsID;
    this.mAdsUnitID = adsUnitID;
    this.mListener = SXPL.SXPluginSDK.ADSListener;
    SXPluginSDKWebLib.VivoNativeAds[adsID] = this;
};

SXPLSXADSOppoVivoMiniNative.prototype.SetOtherParam = function (jsonObject) {
    this.mOtherParm = jsonObject;
};
SXPLSXADSOppoVivoMiniNative.prototype.SetBannerSize = function () {
};
SXPLSXADSOppoVivoMiniNative.prototype.SetBannerPos = function () {
};
SXPLSXADSOppoVivoMiniNative.prototype.ForceUpdatePosition = function (x, y) {
};
SXPLSXADSOppoVivoMiniNative.prototype.LoadAds = function () {
    if (this.mAdsUnitID == null) return;
    this._create();
};
SXPLSXADSOppoVivoMiniNative.prototype.ShowAds = function () {
};
SXPLSXADSOppoVivoMiniNative.prototype.HideAds = function () {
};
SXPLSXADSOppoVivoMiniNative.prototype.Destory = function () {
    this.mIsCreated = false;
    this.mNative = null;
    this.mNativeCurrentAd = null;
};
SXPLSXADSOppoVivoMiniNative.prototype.AdsIsReady = function () {
    return true;
};
SXPLSXADSOppoVivoMiniNative.prototype.IsCreated = function () {
    return this.mIsCreated;
};

//------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------
let SXPLSXADSOppoVivoMiniInterstitial = function () {
    this.m_Interstitial = null;
    this.m_AdsName = null
    this.m_AdsUnitID = null;
    this.m_Listener = null;
    this.m_OtherParm = null;
    this.m_IsCreated = false;
    this.m_IsLoad = false;

    this.m_FullTime = 0;
    this.m_CurTime = 0;
    this.m_Timing = false;
    this.m_TimeFull = false;
};

SXPLSXADSOppoVivoMiniInterstitial.prototype._create = function () {
    this.m_Interstitial = qg.createInterstitialAd({
        posId: this.m_AdsUnitID,
        adUnitId: this.m_AdsUnitID
    });
    this.m_Interstitial.onLoad(this._onLoad.bind(this));
    this.m_Interstitial.onError(this._onError.bind(this));
    this.m_Interstitial.onClose(this._onClose.bind(this));
};

SXPLSXADSOppoVivoMiniInterstitial.prototype._onLoad = function () {
    console.log("SXADSOppoVivoMini Interstitial 加载成功");
    this.m_IsLoad = true;
    this.m_Listener.onAdLoaded(this.m_AdsName);
}

SXPLSXADSOppoVivoMiniInterstitial.prototype._onError = function (error) {
    console.log("SXADSOppoVivoMini Interstitial 加载失败");
    this.m_IsLoad = false;
    this.m_Listener.onAdFailedToLoad(this.m_AdsName, "SXADSOppoVivoMini Interstitial: " + error);
}

SXPLSXADSOppoVivoMiniInterstitial.prototype._onClose = function () {
    if (this.m_TimeFull) {
        this.m_TimeFull = false;
        this.m_Timing = true;
    }
    this.m_Listener.onAdClosed(this.m_AdsName);
}

SXPLSXADSOppoVivoMiniInterstitial.prototype.GetSDKID = function () {
    return 0;
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.Create = function () {
    if (this.m_AdsUnitID == null || this.m_AdsUnitID.length == 0) return;
    this.m_IsCreated = true;
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.Init = function (adsID, adsUnitID) {
    this.m_AdsName = adsID;
    this.m_AdsUnitID = adsUnitID;
    this.m_Listener = SXPL.SXPluginSDK.ADSListener;

    if (this.m_OtherParm && this.m_OtherParm.hasOwnProperty("Time")) {
        this.m_FullTime = parseInt(this.m_OtherParm.Time);
    }

    if (this.m_FullTime > 0) {
        this.m_Timing = true;
        setInterval(() => {
            if (this.m_Timing) {
                this.m_CurTime++;
                console.log("SXADSOppoVivoMini CurTime: " + this.m_CurTime);
                if (this.m_CurTime >= this.m_FullTime) {
                    this.m_CurTime = 0;
                    this.m_Timing = false;
                    this.m_TimeFull = true;
                }
            }
        }, 1000);
    }
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.SetOtherParam = function (jsonObject) {
    this.m_OtherParm = jsonObject;
};
SXPLSXADSOppoVivoMiniInterstitial.prototype.SetBannerSize = function () {
};
SXPLSXADSOppoVivoMiniInterstitial.prototype.SetBannerPos = function () {
};
SXPLSXADSOppoVivoMiniInterstitial.prototype.ForceUpdatePosition = function (x, y) {
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.LoadAds = function () {
    if (this.m_IsCreated) this._create();
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.ShowAds = function () {
    if (!this.m_Interstitial || !this.m_IsLoad) return;
    if (this.m_FullTime > 0 && this.m_TimeFull || this.m_FullTime <= 0) {
        this.m_Interstitial.show().then(() => {
            console.log("SXADSOppoVivoMini Interstitial open");
            this.m_Listener.onAdOpened(this.mAdsName);
        }).catch((err) => {
            switch (err.code) {
                case 30003:
                    console.log("SXADSOppoVivoMini", "新用户7天内不能曝光，请将手机时间调整为7天后，退出游戏重新进入")
                    break;
                case 30009:
                    console.log("SXADSOppoVivoMini", "10秒内调用广告次数超过1次，10秒后再调用")
                    break;
                case 30002:
                    console.log("SXADSOppoVivoMini", "load广告失败，重新加载广告")
                    break;
                default:
                    console.log("SXADSOppoVivoMini", "插屏广告展示失败:" + JSON.stringify(err));
                    break;
            }
        });
    }
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.HideAds = function () {
};
SXPLSXADSOppoVivoMiniInterstitial.prototype.Destory = function () {
    this.m_IsCreated = false;
    this.m_Interstitial = null;
};

SXPLSXADSOppoVivoMiniInterstitial.prototype.AdsIsReady = function () {
    return this.m_IsLoad;
};
SXPLSXADSOppoVivoMiniInterstitial.prototype.IsCreated = function () {
    return this.m_IsCreated;
};

//------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------
let SXPLSXADSOppoVivoMiniRewardVideo = function () {
    this.m_RewardBasedVideo = null;
    this.m_AdsName = null
    this.m_AdsUnitID = null;
    this.m_Listener = null;
    this.m_OtherParm = null;

    this.m_IsCreated = false;
    this.m_IsLoad = false;
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype._create = function () {
    this.m_RewardBasedVideo = qg.createRewardedVideoAd({
        posId: this.m_AdsUnitID,
        adUnitId: this.m_AdsUnitID
    });
    this.m_RewardBasedVideo.onLoad(this._onLoad.bind(this));
    this.m_RewardBasedVideo.onError(this._onError.bind(this));
    this.m_RewardBasedVideo.onClose(this._onClose.bind(this));
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype._onLoad = function () {
    console.log("SXADSOppoVivoMini RewardBasedVideo 加载成功");
    this.m_IsLoad = true;
    this.m_Listener.onAdLoaded(this.m_AdsName);
}

SXPLSXADSOppoVivoMiniRewardVideo.prototype._onError = function (error) {
    console.log("SXADSOppoVivoMini RewardBasedVideo 加载失败");
    this.m_IsLoad = false;
    this.m_Listener.onAdFailedToLoad(this.m_AdsName, "SXADSOppoVivoMini RewardBasedVideo: " + JSON.stringify(error));
}

SXPLSXADSOppoVivoMiniRewardVideo.prototype._onClose = function (res) {
    if (res && res.isEnded) this.m_Listener.onAdRewarded(this.m_AdsName, "complete", 0);
    else this.m_Listener.onAdRewarded(this.m_AdsName, "skip", 0);
    this.m_Listener.onAdClosed(this.m_AdsName);
}

SXPLSXADSOppoVivoMiniRewardVideo.prototype.GetSDKID = function () {
    return 0;
};
SXPLSXADSOppoVivoMiniRewardVideo.prototype.Create = function () {
    if (this.m_AdsUnitID == null || this.m_AdsUnitID.length == 0) return;
    this.m_IsCreated = true;
    this._create();
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.Init = function (adsID, adsUnitID) {
    this.m_AdsName = adsID;
    this.m_AdsUnitID = adsUnitID;
    this.m_Listener = SXPL.SXPluginSDK.ADSListener;
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.SetOtherParam = function (jsonObject) {
    this.m_OtherParm = jsonObject;
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.SetBannerSize = function () {
};
SXPLSXADSOppoVivoMiniRewardVideo.prototype.SetBannerPos = function () {
};
SXPLSXADSOppoVivoMiniRewardVideo.prototype.ForceUpdatePosition = function (x, y) {
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.LoadAds = function () {
    if (this.m_RewardBasedVideo) this.m_RewardBasedVideo.load();
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.ShowAds = function () {
    if (this.m_RewardBasedVideo && this.m_IsLoad) {
        this.m_RewardBasedVideo.show().then(() => {
            console.log("SXADSOppoVivoMini RewardBasedVideo open");
            this.m_Listener.onAdOpened(this.mAdsName);
        });
    }
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.HideAds = function () {
};
SXPLSXADSOppoVivoMiniRewardVideo.prototype.Destory = function () {
};

SXPLSXADSOppoVivoMiniRewardVideo.prototype.AdsIsReady = function () {
    return this.m_IsLoad;
};
SXPLSXADSOppoVivoMiniRewardVideo.prototype.IsCreated = function () {
    return this.m_IsCreated;
};

//------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------

let SXPLSXADSOppoVivoMiniBoxPortal = function () {
    this.mBox = null;
    this.mAdsName = null
    this.mAdsUnitID = null;
    this.mListener = null;
    this.mOtherParm = null;

    this.mIsCreated = false;
    this.mLogicShow = false;
    this.mState = 0;
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype._create = function () {
    if (qg.createBoxPortalAd) {
        if (this.mBox) this.mBox.destroy();

        this.mBox = qg.createBoxPortalAd({
            posId: this.mAdsUnitID,
            adUnitId: this.mAdsUnitID
        });
        this.mBox.onLoad(this._onLoad.bind(this));
        this.mBox.onError(this._onError.bind(this));
        this.mBox.onClose(this._onClose.bind(this));
    }
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype._onLoad = function () {
    console.log("SXADSOppoVivoMini BoxPortal 加载成功");
    if (this.mLogicShow) {
        this.show();
    }
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype._onError = function (error) {
    console.log("SXADSOppoVivoMini BoxPortal 加载失败! " + JSON.stringify(error));
    this.mListener.onAdFailedToLoad(this.mAdsName, "SXADSOppoVivoMini BoxPortal: " + JSON.stringify(error));
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype._onClose = function(){
    console.log("SXADSOppoVivoMini BoxPortal onClose");
    this.mState = BannerState.Hide;
    this.show();
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype.show = function () {
    if (this.mBox && this.mState != BannerState.Show) {
        this.mState = BannerState.Show;
        this.mBox.show().catch(err => {
            console.log("Vivo Mini BoxPortal Show err:" + JSON.stringify(err));
            this.mState = BannerState.None;
        });
    }
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype.GetSDKID = function () {
    return 0
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.Create = function () {
    if (this.mAdsUnitID == null || this.mAdsUnitID.length == 0) return;
    this.mIsCreated = true;
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype.Init = function (adsID, adsUnitID) {
    this.mAdsName = adsID;
    this.mAdsUnitID = adsUnitID;
    this.mListener = SXPL.SXPluginSDK.ADSListener;
};

SXPLSXADSOppoVivoMiniBoxPortal.prototype.SetOtherParam = function (jsonObject) {
    this.mOtherParm = jsonObject;
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.SetBannerSize = function () {
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.SetBannerPos = function () {
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.ForceUpdatePosition = function (x, y) {
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.LoadAds = function () {
    this._create();
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.ShowAds = function () {
    this.mLogicShow = true;
    this.show();
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.HideAds = function () {
    this.mLogicShow = false;
    if (this.mBox) {
        this.mBox.hide();
        this.mState = BannerState.Hide;
    }
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.Destory = function () {
    this.mIsCreated = false;
    if (this.mBox) this.mBox.destroy();
    this.mState = BannerState.None;
    this.mBox = null;
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.AdsIsReady = function () {
    return true;
};
SXPLSXADSOppoVivoMiniBoxPortal.prototype.IsCreated = function () {
    return this.mIsCreated;
};


//------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------

SXPL.SXPluginSDK.AddSXInterfaceADS("com.sunx.oppovivomini.Banner", SXPLSXADSOppoVivoMiniBanner);
SXPL.SXPluginSDK.AddSXInterfaceADS("com.sunx.oppovivomini.Interstitial", SXPLSXADSOppoVivoMiniInterstitial);
SXPL.SXPluginSDK.AddSXInterfaceADS("com.sunx.oppovivomini.RewardBasedVideo", SXPLSXADSOppoVivoMiniRewardVideo);
SXPL.SXPluginSDK.AddSXInterfaceADS("com.sunx.oppovivomini.Native", SXPLSXADSOppoVivoMiniNative);
SXPL.SXPluginSDK.AddSXInterfaceADS("com.sunx.oppovivomini.BoxPortal", SXPLSXADSOppoVivoMiniBoxPortal);